package com.ecomm.demo.messaging.feedback;

import java.io.IOException;

import java.util.Properties;

import javax.jms.*;
import javax.naming.*;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.ecomm.demo.messaging.MDB.FeedbackMessageBean;



public class feedback extends HttpServlet {
	private static final long serialVersionUID = 1L;

	public feedback() {
		super();
	}

	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}

	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}

	public void processRequest(HttpServletRequest request,
			HttpServletResponse response) {
		Logger log=LoggerFactory.getLogger(feedback.class);
		
		String status = "16";
	


		String destinationName = "queue/test";
		
		Context ic = null;
		QueueConnectionFactory cf = null;
		Connection connection =  null;
		MessageProducer publisher = null;
		Session session = null;
		 
		try {        
		
		Properties props = new Properties();
		props.setProperty("java.naming.factory.initial", "org.jboss.as.naming.InitialContextFactory");
		props.setProperty("java.naming.factory.url.pkgs", "org.jboss.naming");
		props.setProperty("java.naming.provider.url", "localhost");
		ic = new InitialContext(props);
		cf = (QueueConnectionFactory)ic.lookup("java:/JmsXA");
		//cf = (QueueConnectionFactory)ic.lookup("java:/ConnectionFactory");
		
		Queue queue = (Queue)ic.lookup(destinationName);
		 
		connection = cf.createConnection();
		//AUTO_ACKNOWLEDGE mode follows the policy of delivering the message once-and-only once but this incurs an overhead on the server to maintain this policy .
		session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
		publisher = session.createProducer(queue);
		
		connection.start();
	
		FeedbackMessageBean mymesage=new FeedbackMessageBean();
		mymesage.setStatus(status);
		
				
		ObjectMessage  msg = session.createObjectMessage(mymesage);

		publisher.send(msg);
		System.out.println("Message sento to the JMS Provider");
		 
		}
		catch (Exception exc) {
		exc.printStackTrace();
		}
		finally {    
			if(ic != null){
				try {
					ic.close();
				} catch (NamingException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}	
			if(publisher != null){
				try {
					publisher.close();
				} catch (JMSException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		
			if (connection != null)   {
				try {
					connection.close();
				} catch (JMSException e) {                   
					e.printStackTrace();
				}
			}
			if(session != null){
				try {
					
					session.close();
				} catch (JMSException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}	

		}

	
	}
}